
package PCOMM1;


//   PCOMM1:   : )          
//      )            . 
//                , 
//            .        .



// :  JavaTimPonuda     Receiver (DusanSavic)  .
class SefLaboratorije   // Client
{ DusanSavic ds;
  SILAB sil;
  SefLaboratorije(){ds = new DusanSavic();sil = new JavaTimPonuda(ds);} // Povezivanje ConcreteCommand i Receiver objekta.
  SILAB vratiTimPonuda(){return sil;}
}

// :  SILAB      (vratiVremeZaIzraduPonude()).
class UpravaFakulteta  //Invoker
{
  SILAB sil;
  UpravaFakulteta(SILAB sil1){sil = sil1;}

  public static void main(String args[])
     {  UpravaFakulteta uf;
        SefLaboratorije sl = new  SefLaboratorije();
        SILAB sil1 = sl.vratiTimPonuda();
        uf = new UpravaFakulteta(sil1);
        System.out.println(uf.vratiVremeZaIzraduPonude());
     }

  String vratiVremeZaIzraduPonude(){return sil.vratiVremeZaIzraduPonude();}
}


// :      Execute().
abstract class SILAB // Command
{
  abstract String vratiVremeZaIzraduPonude();
}


// :     ClanJavaTima  (cjt)   (proceniVremeZaPonudu().  
//  vratiVremeZaIzraduPonude ()   metodu proceniVremeZaPonudu() ClanJavaTima .
class JavaTimPonuda extends SILAB   // ConcreteCommand
{ ClanJavaTima cjt;
  String procenaVremena;
  JavaTimPonuda(ClanJavaTima cjt1){cjt=cjt1;}
  @Override
  String vratiVremeZaIzraduPonude(){procenaVremena = cjt.proceniVremeZaPonudu(); return procenaVremena; }
}


abstract class ClanJavaTima
{abstract String proceniVremeZaPonudu();
}

// :     proceniVremeZaPonudu ()      
//  (vratiVremeZaIzraduPonude()). 
class DusanSavic  extends ClanJavaTima// Receiver
{ @Override
  String proceniVremeZaPonudu(){return "Potrebno je 2 dana da se napravi ponuda";}
}
