
package PCOR1;


//   PCOR1:                
//     .      Handler    .

class UpravaFakulteta   
{ SILAB sil; 
  UpravaFakulteta(SILAB sil1){sil = sil1;}

  void Konstruisi()
    { sil.kreirajProgramskiJezik();
      sil.kreirajSUBP();
      sil.kreirajPonudu();
    }
 public static void main(String args[])
    {   UpravaFakulteta uf;
        DusanSavic ds = new DusanSavic(null,true);
        IlijaAntovic ia = new IlijaAntovic(ds,true);
        VojislavStanojevic vs = new VojislavStanojevic(ia,true);
        MilosMilic mm = new MilosMilic(vs,true);
        JavaTimPonuda jat = new JavaTimPonuda(mm);
        uf = new UpravaFakulteta(jat);
        uf.Konstruisi();
        System.out.println(jat.vratiPonudu()); }}

abstract class  SILAB
{  ProgramskiJezik  pj;
    SUBP subp;
    Ponuda pon;

   abstract void kreirajProgramskiJezik();
   abstract void kreirajSUBP();
   abstract void kreirajPonudu();
   abstract String vratiPonudu();
 }

class Ponuda {String ponuda;}
// :       .
class JavaTimPonuda extends SILAB  // Client
{ ClanJavaTima cjt;
  JavaTimPonuda() {pon = new Ponuda();}
  JavaTimPonuda(ClanJavaTima cjt1){cjt = cjt1;pon = new Ponuda();}

  @Override
  public void kreirajProgramskiJezik(){pj = new Java();}
  @Override
  public void kreirajSUBP() { subp = new MySQL();}
  @Override
  public void kreirajPonudu(){pon.ponuda = "Programski jezik-" + pj.vratiProgramskiJezik() + "  SUBP-" + subp.vratiSUBP() 
                              + " " + utrosenoVreme();}
   @Override
  public String vratiPonudu(){return pon.ponuda;}
  String utrosenoVreme(){return cjt.utrosenoVreme();}
}

// :     .   (cjt)   ClanJavaTima .
abstract class ClanJavaTima // Handler
{  ClanJavaTima cjt;
   boolean radioNaPonudi;
   ClanJavaTima(ClanJavaTima cjt1,boolean radioNaPonudi1){cjt = cjt1;
                          radioNaPonudi=radioNaPonudi1;}
   String utrosenoVreme()
   {       String uvreme = "";
           if (radioNaPonudi == true) uvreme = "\nUtroseno vreme:" + vratiVreme() + " ";
           if (cjt!=null ) uvreme = uvreme + cjt.utrosenoVreme(); // Lifo lista
           // uvreme = cjt.utrosenoVreme() + uvreme; - Fifo lista
          return uvreme;
   }
   abstract String vratiVreme();
}

// :      .    .       
//  ,     .
class DusanSavic extends ClanJavaTima  // ConcreteHandler1
{ DusanSavic(ClanJavaTima cjt1,boolean radioNaPonudi1){super(cjt1,radioNaPonudi1);}
  @Override
  String vratiVreme(){return " Dusan Savic - 2h";}}

class IlijaAntovic extends ClanJavaTima  // ConcreteHandler2
{ IlijaAntovic(ClanJavaTima cjt1,boolean radioNaPonudi1){super(cjt1,radioNaPonudi1);}
  @Override
  String vratiVreme(){return " Ilija Antovic - 1h 50'";}}

class MilosMilic extends ClanJavaTima  // ConcreteHandler4
{MilosMilic(ClanJavaTima cjt1,boolean radioNaPonudi1){super(cjt1,radioNaPonudi1);}
 @Override
 String vratiVreme(){return " Milos Milic - 1h 40'";}}

class VojislavStanojevic extends ClanJavaTima  // ConcreteHandler3
{ VojislavStanojevic(ClanJavaTima cjt1,boolean radioNaPonudi1){super(cjt1,radioNaPonudi1);}
  @Override
  String vratiVreme(){return " Vojislav Stanojevic - 1 30'";}}



interface ProgramskiJezik {String vratiProgramskiJezik();}
class Java implements ProgramskiJezik {
    @Override
    public String vratiProgramskiJezik(){return "Java";}}
class VB implements ProgramskiJezik {
    @Override
    public String vratiProgramskiJezik(){return "VB";}}
interface SUBP {String vratiSUBP();}
class MySQL implements SUBP{
    @Override
    public String vratiSUBP(){return "MySQL";}}
class MSAccess implements SUBP{
    @Override
    public String vratiSUBP(){return "MS Access";}
}
