package RZITR1;

//   RZITR1:           : 
// Items:
// 4
// 2
// 1
// 5
// 3

class Client   
{ Aggregate ag;
  Iterator it;
  Client(){ag=new ConcreteAggregate();it = ag.createIterator();}
  public static void main(String args[])
    {  Client cl = new Client();
       cl.printItems();
    }

  void printItems()
  {  System.out.println("Items:");
     it.First();
     while(it.IsEnd())
        { System.out.println(it.currentItem());
          it.Next();
        }
  }
}


abstract class  Aggregate 
{  int n[];
   abstract Iterator createIterator();
   int getItem(int indeks) {return n[indeks];}
   int getItemsNumber(){return n.length;}
}

class ConcreteAggregate extends Aggregate   
{ ConcreteAggregate()
   {  n = new int[5];
      n[0]=4;
      n[1]=2;
      n[2]=1;
      n[3]=5;
      n[4]=3;
   }

   @Override
   Iterator createIterator() { return new ConcreteIterator(this);}
}


abstract class Iterator 
{ abstract void First();
  abstract void Next();
  abstract boolean IsEnd();
  abstract int currentItem();
}

class ConcreteIterator extends Iterator  
{ ConcreteAggregate ag;
  int indeks;

  ConcreteIterator(ConcreteAggregate ag1) {ag = ag1;}
  @Override
  void First() {indeks = 0;}
  @Override
  void Next() {indeks++;}
  @Override
  boolean IsEnd () {return indeks < ag.getItemsNumber();}
  @Override
  int currentItem() {return ag.getItem(indeks);}
  }
